/*
Sistemas Integrados TEKNISA
Nome: 3884_VNDTRGO_TRIGGER_MOVPONTOCONS.SQL
Descrio: Atualiza o saldo de pontos do consumidor na tabela SALDOCONSCAMP
Criao: 26/11/2012 Andreza Valgas
*/

CREATE OR REPLACE TRIGGER SALDO_MOVPONTOCONS
BEFORE INSERT OR DELETE
ON MOVPONTOCONS FOR EACH ROW

DECLARE
   V_VRMOVPONTOCONS FLOAT;
   V_NRDADOS INTEGER;

BEGIN
   IF INSERTING THEN
      SELECT COUNT(*) INTO V_NRDADOS
        FROM SALDOCONSCAMP
       WHERE CDCAMPANHA   = :NEW.CDCAMPANHA
         AND CDCLIENTE    = :NEW.CDCLIENTE
         AND CDCONSUMIDOR = :NEW.CDCONSUMIDOR;


      IF :NEW.IDTPMOVCONS = 'C' THEN
         V_VRMOVPONTOCONS := :NEW.VRMOVPONTOCONS;
      ELSE
         V_VRMOVPONTOCONS := :NEW.VRMOVPONTOCONS * (-1);
      END IF;

      IF V_NRDADOS = 0 THEN
         INSERT INTO SALDOCONSCAMP
            (CDCAMPANHA, CDCLIENTE, CDCONSUMIDOR, VRSALDOCONS, VRVENDARESTCONS, QTVENDARESTCONS, DTINCLUSAO)
         VALUES
            (:NEW.CDCAMPANHA, :NEW.CDCLIENTE, :NEW.CDCONSUMIDOR, V_VRMOVPONTOCONS, 0, 0, SYSDATE);
      ELSE
         UPDATE SALDOCONSCAMP
            SET VRSALDOCONS = VRSALDOCONS + V_VRMOVPONTOCONS
          WHERE CDCAMPANHA   = :NEW.CDCAMPANHA
            AND CDCLIENTE    = :NEW.CDCLIENTE
            AND CDCONSUMIDOR = :NEW.CDCONSUMIDOR;
      END IF;
   END IF;

   IF DELETING THEN
      IF :OLD.IDTPMOVCONS = 'C' THEN
         V_VRMOVPONTOCONS := :OLD.VRMOVPONTOCONS * (-1);
      ELSE
         V_VRMOVPONTOCONS := :OLD.VRMOVPONTOCONS;
      END IF;

      UPDATE SALDOCONSCAMP
         SET VRSALDOCONS = VRSALDOCONS + V_VRMOVPONTOCONS
       WHERE CDCAMPANHA   = :OLD.CDCAMPANHA
         AND CDCLIENTE    = :OLD.CDCLIENTE
         AND CDCONSUMIDOR = :OLD.CDCONSUMIDOR;
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('SALDO_MOVPONTOCONS','5.50.000'); 
END;
/